#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void print_array(float *p, unsigned int num){
	int i;

	for (i = 0; i < num; i++){
		printf("%u %f\n", i, p[i]);
	}
}

void fprint_array(FILE *f, float *p, unsigned int num){
	int i;

	for (i = 0; i < num; i++){
		fprintf(f, "%u %f\n", i, p[i]);
	}
}

int main(){
	int i = 0, j = 0;
	FILE *fp;
	float x[] = { 0, -1.0000, -1.2000, 2.0000, 1.4000, 1.4000, 0.5000, 0, -0.6000 };
	float h[] = { 1.0000, -0.6000, -0.3000, -0.1000 };
	float y[12];
	char name[63];

	memset(name, 0, sizeof(name));

//	printf("%d %d\n", sizeof(y), sizeof(y) / sizeof(float));

	// konvoluce
	for( i = 0; i < sizeof(x) / sizeof(float); i++ ){
		snprintf(name, sizeof(name) - 1, "x_%u.csv", i);
		fp = fopen(name, "w");
		fprintf(fp, "# x[%u] h[n - %u] \n", i, i);
		fprintf(fp, "# x[%u] = %f \n", i, x[i]);
		memset(y, 0, sizeof(y));
		
		for ( j = 0; j < sizeof(h) / sizeof(float); j++){
			y[i+j] = y[i+j] + x[i] * h[j];	
		}

		fprint_array(fp, y, sizeof(y) / sizeof(float));
		close(fp);
	}

	return 0;
}
