set output "gaus.mp"
set term mp color "csr10"; 
set format y "$%2.0f$" 
set format x "$ %2.0f$" 
set format z "$ %2.1f$" 
set grid; 
set tmargin 3; 
set rmargin 3; 
set bmargin 3;
set dgrid3d;
#set size square; 
set yrange [-3:3]; 
set xrange [-3:3]; 
#set xtics(0,1,2,3,4,5,6,7,8,9,10,11); 
#set xlabel '$x$ [n]'; 
set samples 2500; 
set hidden3d 
set ticslevel 0.2
set isosample 50

sigma = 0.75;
splot 1/(2*pi*sigma**2)*exp(-((x**2+y**2)/(2*sigma**2))) notitle;

